<template>
  <slot
    v-if="isGroupChat === false"
    :disable="!!connectionState"
    :make-call="onMakeCall"
  />
</template>

<script setup lang="ts">
import { inject, PropType, computed } from 'vue';
import { DialogPlugin } from '@new-jira-clone/ui/src/plugins/dialog';
import { ChatTypes, IChat, IUser } from '@/shared';
import ConnectionAnswer from './ConnectionAnswer.vue';
import useCreateCallOffer from '../model/useCreateCallOffer';
import { useMediaStreamStore } from '../model/useMediaStreamStore';
import useCreateCallAnswer from '../model/useCreateCallAnswer';

const props = defineProps({
  chatId: {
    type: String,
    required: true,
  },
  callTarget: {
    type: Object as PropType<IChat | IUser>,
    required: true,
  },
  video: {
    type: Boolean,
    default: false,
  },
  audio: {
    type: Boolean,
    default: false,
  },
});

const $dialog = inject('$dialog') as DialogPlugin;

const { isExistOffer, getConnectionState, getRtcDescription } = useMediaStreamStore();
const { makeCall } = useCreateCallOffer();

const connectionState = getConnectionState(props.chatId);
const rtcDescription = getRtcDescription(props.chatId);

const onMakeCall = () => {
  if (isExistOffer(props.chatId) && rtcDescription.value) {
    const { createCallAnswer } = useCreateCallAnswer();

    try {
      createCallAnswer(props.chatId, rtcDescription.value, props.video);

      $dialog.show(ConnectionAnswer, {
        contentProps: {
          connectionTarget: props.callTarget,
        },
      });
    } catch (error) {
      console.log(error);
    }
    return;
  }

  if (!connectionState.value) {
    makeCall(props.chatId, props.callTarget, { video: props.video, audio: props.audio });
  }
};

const isGroupChat = computed(() => {
  if ('type' in props.callTarget && props.callTarget.type === ChatTypes.Group) {
    return true;
  }

  return false;
});
</script>
